#┌─────────────────────────────────
#│ WEB CALEN : make_rss.pl - 2016/11/24
#│ copyright (c) TRANSFORM, Since 2012
#│ http://drc3.news-site.net/script1/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

#-----------------------------------------------------------
#  RSS 2.0 作成
#-----------------------------------------------------------
sub make_rss {
	# 年月モード
	my $date_mode;
	
	# 現在の年月
	my ($mday,$mon,$year) = (localtime())[3 .. 5];
	$mon = sprintf("%02d",++$mon);
	$year += 1900;
	
	# datepicker
	if ($in{warp} =~ m|^(\d{4})/(\d{2})|) {
		$date_mode++;
		$in{y} = $1;
		$in{m} = $2;
	
	# カレンダ指定
	} elsif ($in{read} =~ /^(\d{4})(\d{2})(\d{2})$/) {
		$date_mode++;
		$in{y} = $1;
		$in{m} = $2;
		$in{d} = $3;
		
	} else {
		# 年月引数
		$in{y} =~ s/\D//g;
		$in{m} =~ s/\D//g;
		
		if ($in{y} < 1970 or $in{m} < 1 or $in{m} > 12) {
			$in{y} = $year;
			$in{m} = $mon;
		} else {
			$in{m} = sprintf("%02d",$in{m});
			$date_mode++;
		}
	}
	
	# データ読み込み
	my ($ttl,$log,$ym,$pgs) =
			$in{mode} eq 'news' ? read_news() : $in{y} && $in{m} && $in{d} ? read_data($in{y},$in{m},$in{d}) : $date_mode ? read_data($in{y},$in{m}) :read_news();

	# RSS
	my $rss = <<EOM;
<?xml version="1.0" encoding="utf-8" ?>
<rss version="2.0">
	<channel>
		<title>$cf{cgi_title}</title>
		<link>$cf{calen_cgi}</link>
		<description> $cf{sub_ttl}</description>
		<language>ja</language>
		<generator>$cf{version}</generator>
EOM

	my $i = 0;
	foreach (@{$log}) {
		my ($day,$sub,$msg,$ico,$wico,$img1,$img2,$img3,$tube) = split(/<>/);
		$i++;
		my ($y,$m) = $$ym{$i} =~ /^(\d{4})(\d{2})$/ && ($1,$2);
		my $date = "$y$m$day";

		# 日付文字列から年月取得
		my $year = substr($date,0,4);
		my $mon = substr($date,4,2);
		my $mday = substr($date,6,2);

		# Time::Localモジュールを宣言
		use Time::Local 'timelocal';
		# エポック秒を取得
		my $epc = timelocal(0, 0, 0, $mday, $mon-1, $year-1900);

		# HTTP::Dateモジュール(日付変換ルーチン)を宣言
		use HTTP::Date 'time2str';
		# RFC 822変換
		my $str = time2str($epc);
		
		$msg = chg_rsstag($msg);
		
		$rss .= qq|\t\t<item>\n|;
		$rss .= qq|\t\t\t<title>$sub</title>\n|;
		$rss .= qq|\t\t\t<link>$cf{calen_cgi}?read=$date</link>\n|;
		$rss .= qq|\t\t\t<description>$msg</description>\n|;
		$rss .= qq|\t\t\t<pubDate>$str +0900</pubDate>\n|;
		$rss .= qq|\t\t</item>\n|;
	}
	$rss .= "\t</channel>\n</rss>\n";

	# RSS書込
	open(RSS,"> $cf{htmldir}/index.xml");
	print RSS $rss;
	close(RSS);
}

#-----------------------------------------------------------
#  文字数カット for Shift-JIS
#-----------------------------------------------------------
sub cut_str {
	my $str = shift;
	$str =~ s|<br( /)?>||g;
	
	my $i = 0;
	my $ret;
	while($str =~ /([\x00-\x7F\xA1-\xDF]|[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC])/gx) {
		$i++;
		$ret .= $1;
		last if ($i >= 40);
	}
	return $ret;
}

#-----------------------------------------------------------
#  タグ復元
#-----------------------------------------------------------
sub chg_rsstag {
	local($_) = @_;
	
	s/&/&amp;/g;
	s/"/&quot;/g;
	s/</&lt;/g;
	s/>/&gt;/g;
	s/'/&#39;/g;
	$_;
}


1;

